diff --git a/alias.c b/alias.c
index a7f14fb446..7af0307c48 100644
--- a/alias.c
+++ b/alias.c
@@ -54,10 +54,9 @@ struct Address *mutt_lookup_alias(const char *s)
   return NULL; /* no such alias */
 }
 
-static struct Address *expand_aliases_r(struct Address *a, struct List **expn)
+static struct Address *expand_aliases_r(struct Address *a, struct STailQHead *expn)
 {
   struct Address *head = NULL, *last = NULL, *t = NULL, *w = NULL;
-  struct List *u = NULL;
   bool i;
   const char *fqdn = NULL;
 
@@ -70,9 +69,10 @@ static struct Address *expand_aliases_r(struct Address *a, struct List **expn)
       if (t)
       {
         i = false;
-        for (u = *expn; u; u = u->next)
+        struct STailQNode *np = NULL;
+        STAILQ_FOREACH(np, expn, entries)
         {
-          if (mutt_strcmp(a->mailbox, u->data) == 0) /* alias already found */
+          if (mutt_strcmp(a->mailbox, np->data) == 0) /* alias already found */
           {
             mutt_debug(1, "expand_aliases_r(): loop in alias found for '%s'\n", a->mailbox);
             i = true;
@@ -82,10 +82,7 @@ static struct Address *expand_aliases_r(struct Address *a, struct List **expn)
 
         if (!i)
         {
-          u = safe_malloc(sizeof(struct List));
-          u->data = safe_strdup(a->mailbox);
-          u->next = *expn;
-          *expn = u;
+          mutt_stailq_insert_head(expn, safe_strdup(a->mailbox));
           w = rfc822_cpy_adr(t, 0);
           w = expand_aliases_r(w, expn);
           if (head)
@@ -138,10 +135,11 @@ static struct Address *expand_aliases_r(struct Address *a, struct List **expn)
 struct Address *mutt_expand_aliases(struct Address *a)
 {
   struct Address *t = NULL;
-  struct List *expn = NULL; /* previously expanded aliases to avoid loops */
+  struct STailQHead expn; /* previously expanded aliases to avoid loops */
 
+  STAILQ_INIT(&expn);
   t = expand_aliases_r(a, &expn);
-  mutt_free_list(&expn);
+  mutt_stailq_free(&expn);
   return (mutt_remove_duplicates(t));
 }
 
diff --git a/list.h b/list.h
index 9d4b0eb229..ccd3f78008 100644
--- a/list.h
+++ b/list.h
@@ -26,20 +26,6 @@
 #include <string.h>
 #include "lib/lib.h"
 
-/**
- * struct List - Singly-linked List type
- */
-struct List
-{
-  char *data;
-  struct List *next;
-};
-
-static inline struct List *mutt_new_list(void)
-{
-  return safe_calloc(1, sizeof(struct List));
-}
-
 /**
  * New implementation using macros from queue.h
  */
@@ -53,7 +39,8 @@ struct STailQNode
     STAILQ_ENTRY(STailQNode) entries;
 };
 
-static inline struct STailQNode* mutt_stailq_insert_head(struct STailQHead *h, char *s)
+static inline struct STailQNode* mutt_stailq_insert_head(struct STailQHead *h,
+                                                         char *s)
 {
   struct STailQNode *np = safe_calloc(1, sizeof(struct STailQNode));
   np->data = s;
@@ -61,7 +48,8 @@ static inline struct STailQNode* mutt_stailq_insert_head(struct STailQHead *h, c
   return np;
 }
 
-static inline struct STailQNode* mutt_stailq_insert_tail(struct STailQHead *h, char * s)
+static inline struct STailQNode* mutt_stailq_insert_tail(struct STailQHead *h,
+                                                         char *s)
 {
   struct STailQNode *np = safe_calloc(1, sizeof(struct STailQNode));
   np->data = s;
@@ -69,6 +57,16 @@ static inline struct STailQNode* mutt_stailq_insert_tail(struct STailQHead *h, c
   return np;
 }
 
+static inline struct STailQNode* mutt_stailq_insert_after(struct STailQHead *h,
+                                                          struct STailQNode *n,
+                                                          char *s)
+{
+  struct STailQNode *np = safe_calloc(1, sizeof(struct STailQNode));
+  np->data = s;
+  STAILQ_INSERT_AFTER(h, n, np, entries);
+  return np;
+}
+
 static inline struct STailQNode *mutt_stailq_find(struct STailQHead *h, const char *data)
 {
   struct STailQNode *np = NULL;
@@ -95,6 +93,22 @@ static inline void mutt_stailq_free(struct STailQHead *h)
   STAILQ_INIT(h);
 }
 
+static inline void mutt_stailq_clear(struct STailQHead *h)
+{
+  struct STailQNode *np = STAILQ_FIRST(h), *next = NULL;
+  while (np)
+  {
+      next = STAILQ_NEXT(np, entries);
+      FREE(&np);
+      np = next;
+  }
+  STAILQ_INIT(h);
+}
+
+/**
+ * mutt_stailq_match - Is the string in the list
+ * @return true if the header contained in "s" is in list "h"
+ */
 static inline bool mutt_stailq_match(const char *s, struct STailQHead *h)
 {
   struct STailQNode *np;
diff --git a/mutt.h b/mutt.h
index e76d898d98..15d1245424 100644
--- a/mutt.h
+++ b/mutt.h
@@ -30,7 +30,6 @@
 #include <stddef.h>
 #include <stdio.h>
 
-struct List;
 struct ReplaceList;
 struct RxList;
 struct State;
@@ -320,15 +319,11 @@ enum QuadOptionVars
 #define MUTT_X_MOZILLA_KEYS (1 << 2) /**< tbird */
 #define MUTT_KEYWORDS       (1 << 3) /**< rfc2822 */
 
-void mutt_free_list(struct List **list);
 void mutt_free_rx_list(struct RxList **list);
 void mutt_free_replace_list(struct ReplaceList **list);
 int mutt_matches_ignore(const char *s);
 
 /* add an element to a list */
-struct List *mutt_add_list(struct List *head, const char *data);
-struct List *mutt_add_list_n(struct List *head, const void *data, size_t len);
-struct List *mutt_find_list(struct List *l, const char *data);
 int mutt_remove_from_rx_list(struct RxList **l, const char *str);
 
 void mutt_init(int skip_sys_rc, struct STailQHead *commands);
diff --git a/muttlib.c b/muttlib.c
index 2c601a5854..aebae3cf96 100644
--- a/muttlib.c
+++ b/muttlib.c
@@ -244,49 +244,6 @@ void mutt_free_body(struct Body **p)
   *p = 0;
 }
 
-struct List *mutt_add_list(struct List *head, const char *data)
-{
-  size_t len = mutt_strlen(data);
-
-  return mutt_add_list_n(head, data, len ? len + 1 : 0);
-}
-
-struct List *mutt_add_list_n(struct List *head, const void *data, size_t len)
-{
-  struct List *tmp = NULL;
-
-  for (tmp = head; tmp && tmp->next; tmp = tmp->next)
-    ;
-  if (tmp)
-  {
-    tmp->next = safe_malloc(sizeof(struct List));
-    tmp = tmp->next;
-  }
-  else
-    head = tmp = safe_malloc(sizeof(struct List));
-
-  tmp->data = safe_malloc(len);
-  if (len)
-    memcpy(tmp->data, data, len);
-  tmp->next = NULL;
-  return head;
-}
-
-struct List *mutt_find_list(struct List *l, const char *data)
-{
-  struct List *p = l;
-
-  while (p)
-  {
-    if (data == p->data)
-      return p;
-    if (data && p->data && (mutt_strcmp(p->data, data) == 0))
-      return p;
-    p = p->next;
-  }
-  return NULL;
-}
-
 int mutt_remove_from_rx_list(struct RxList **l, const char *str)
 {
   struct RxList *p = NULL, *last = NULL;
@@ -323,21 +280,6 @@ int mutt_remove_from_rx_list(struct RxList **l, const char *str)
   return rv;
 }
 
-void mutt_free_list(struct List **list)
-{
-  struct List *p = NULL;
-
-  if (!list)
-    return;
-  while (*list)
-  {
-    p = *list;
-    *list = (*list)->next;
-    FREE(&p->data);
-    FREE(&p);
-  }
-}
-
 void mutt_free_header(struct Header **h)
 {
   if (!h || !*h)
diff --git a/thread.c b/thread.c
index 47c01ac874..4eaaba3928 100644
--- a/thread.c
+++ b/thread.c
@@ -373,12 +373,11 @@ void mutt_draw_tree(struct Context *ctx)
  * most immediate existing descendants.  we also note the earliest
  * date on any of the parents and put it in *dateptr.
  */
-static struct List *make_subject_list(struct MuttThread *cur, time_t *dateptr)
+static void make_subject_list(struct STailQHead *subjects, struct MuttThread *cur, time_t *dateptr)
 {
   struct MuttThread *start = cur;
   struct Envelope *env = NULL;
   time_t thisdate;
-  struct List *curlist = NULL, *oldlist = NULL, *newlist = NULL, *subjects = NULL;
   int rc = 0;
 
   while (true)
@@ -397,28 +396,17 @@ static struct List *make_subject_list(struct MuttThread *cur, time_t *dateptr)
     env = cur->message->env;
     if (env->real_subj && ((env->real_subj != env->subject) || (!option(OPT_SORT_RE))))
     {
-      for (curlist = subjects, oldlist = NULL; curlist;
-           oldlist = curlist, curlist = curlist->next)
+      struct STailQNode *np;
+      STAILQ_FOREACH(np, subjects, entries)
       {
-        rc = mutt_strcmp(env->real_subj, curlist->data);
+        rc = mutt_strcmp(env->real_subj, np->data);
         if (rc >= 0)
           break;
       }
-      if (!curlist || rc > 0)
-      {
-        newlist = safe_calloc(1, sizeof(struct List));
-        newlist->data = env->real_subj;
-        if (oldlist)
-        {
-          newlist->next = oldlist->next;
-          oldlist->next = newlist;
-        }
-        else
-        {
-          newlist->next = subjects;
-          subjects = newlist;
-        }
-      }
+      if (!np)
+          mutt_stailq_insert_head(subjects, env->real_subj);
+      else if (rc > 0)
+          mutt_stailq_insert_after(subjects, np, env->real_subj);
     }
 
     while (!cur->next && cur != start)
@@ -429,8 +417,6 @@ static struct List *make_subject_list(struct MuttThread *cur, time_t *dateptr)
       break;
     cur = cur->next;
   }
-
-  return subjects;
 }
 
 /**
@@ -443,14 +429,15 @@ static struct MuttThread *find_subject(struct Context *ctx, struct MuttThread *c
 {
   struct HashElem *ptr = NULL;
   struct MuttThread *tmp = NULL, *last = NULL;
-  struct List *subjects = NULL, *oldlist = NULL;
+  struct STailQHead subjects = STAILQ_HEAD_INITIALIZER(subjects);
   time_t date = 0;
 
-  subjects = make_subject_list(cur, &date);
+  make_subject_list(&subjects, cur, &date);
 
-  while (subjects)
+  struct STailQNode *np;
+  STAILQ_FOREACH(np, &subjects, entries)
   {
-    for (ptr = hash_find_bucket(ctx->subj_hash, subjects->data); ptr; ptr = ptr->next)
+    for (ptr = hash_find_bucket(ctx->subj_hash, np->data); ptr; ptr = ptr->next)
     {
       tmp = ((struct Header *) ptr->data)->thread;
       if (tmp != cur &&                    /* don't match the same message */
@@ -463,16 +450,14 @@ static struct MuttThread *find_subject(struct Context *ctx, struct MuttThread *c
                          (last->message->received < tmp->message->received) :
                          (last->message->date_sent < tmp->message->date_sent))) &&
           tmp->message->env->real_subj &&
-          (mutt_strcmp(subjects->data, tmp->message->env->real_subj) == 0))
+          (mutt_strcmp(np->data, tmp->message->env->real_subj) == 0))
       {
         last = tmp; /* best match so far */
       }
     }
-
-    oldlist = subjects;
-    subjects = subjects->next;
-    FREE(&oldlist);
   }
+
+  mutt_stailq_clear(&subjects);
   return last;
 }
 
